searchNodes=[{"doc":"Checks, fetches and delivers configurable data sources. Usage Place a porterage instance in your supervision tree: {Porterage, %{ deliverer: MyDeliverer, deliverer_opts: %{}, fetcher: MyFetcher, fetcher_opts: %{}, scheduler: MyScheduler, scheduler_opts: %{}, supervisor: [], tester: MyTester, tester_opts: %{} }} See config/0 for a specification of the available configuration keys. Supervisor Configuration If a :supervisor key is set the values are passed as the options argument to Supervisor.start_link/3. Data Flow Porterage.Scheduler Depending on the :scheduler chosen a :tick will start the data flow. Porterage.Tester If the scheduler decided it is time to test the data source the chosen :tester will receive a notification to do so. Porterage.Fetcher Every time a test for new data was deemed successful the :fetcher will retrieve the data to be delivered. Porterage.Deliverer Once the data was fetched in the previous step the :deliverer will take care of delivering it to the target. Every step of the flow can be manually triggered.","ref":"Porterage.html","title":"Porterage","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor.","ref":"Porterage.html#child_spec/1","title":"Porterage.child_spec/1","type":"function"},{"doc":"Force a delivery for a specific instance with custom data.","ref":"Porterage.html#deliver/2","title":"Porterage.deliver/2","type":"function"},{"doc":"Force a fetch for a specific instance.","ref":"Porterage.html#fetch/1","title":"Porterage.fetch/1","type":"function"},{"doc":"Force a test for a specific instance.","ref":"Porterage.html#test/1","title":"Porterage.test/1","type":"function"},{"doc":"Force a tick for a specific instance.","ref":"Porterage.html#tick/1","title":"Porterage.tick/1","type":"function"},{"doc":"","ref":"Porterage.html#t:config/0","title":"Porterage.config/0","type":"type"},{"doc":"Delivers a data package to a configured destination.","ref":"Porterage.Deliverer.html","title":"Porterage.Deliverer","type":"behaviour"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor.","ref":"Porterage.Deliverer.html#child_spec/1","title":"Porterage.Deliverer.child_spec/1","type":"function"},{"doc":"Execute a run of the deliverer module.","ref":"Porterage.Deliverer.html#c:deliver/2","title":"Porterage.Deliverer.deliver/2","type":"callback"},{"doc":"Optional state initialization.","ref":"Porterage.Deliverer.html#c:init/1","title":"Porterage.Deliverer.init/1","type":"callback"},{"doc":"","ref":"Porterage.Deliverer.html#t:state/0","title":"Porterage.Deliverer.state/0","type":"type"},{"doc":"Tries to fetch the configured data source and pass it on for delivery.","ref":"Porterage.Fetcher.html","title":"Porterage.Fetcher","type":"behaviour"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor.","ref":"Porterage.Fetcher.html#child_spec/1","title":"Porterage.Fetcher.child_spec/1","type":"function"},{"doc":"Execute a run of the fetcher module.","ref":"Porterage.Fetcher.html#c:fetch/1","title":"Porterage.Fetcher.fetch/1","type":"callback"},{"doc":"Optional state initialization.","ref":"Porterage.Fetcher.html#c:init/1","title":"Porterage.Fetcher.init/1","type":"callback"},{"doc":"","ref":"Porterage.Fetcher.html#t:fetch_result/0","title":"Porterage.Fetcher.fetch_result/0","type":"type"},{"doc":"","ref":"Porterage.Fetcher.html#t:state/0","title":"Porterage.Fetcher.state/0","type":"type"},{"doc":"Takes care of (periodically) triggering the chosen tester module.","ref":"Porterage.Scheduler.html","title":"Porterage.Scheduler","type":"behaviour"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor.","ref":"Porterage.Scheduler.html#child_spec/1","title":"Porterage.Scheduler.child_spec/1","type":"function"},{"doc":"Optional state initialization.","ref":"Porterage.Scheduler.html#c:init/1","title":"Porterage.Scheduler.init/1","type":"callback"},{"doc":"Execute a run of the scheduler module.","ref":"Porterage.Scheduler.html#c:tick/1","title":"Porterage.Scheduler.tick/1","type":"callback"},{"doc":"","ref":"Porterage.Scheduler.html#t:state/0","title":"Porterage.Scheduler.state/0","type":"type"},{"doc":"","ref":"Porterage.Scheduler.html#t:tick_result/0","title":"Porterage.Scheduler.tick_result/0","type":"type"},{"doc":"Tests if data should be fetched and delivered after the last scheduler tick.","ref":"Porterage.Tester.html","title":"Porterage.Tester","type":"behaviour"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor.","ref":"Porterage.Tester.html#child_spec/1","title":"Porterage.Tester.child_spec/1","type":"function"},{"doc":"Optional state initialization.","ref":"Porterage.Tester.html#c:init/1","title":"Porterage.Tester.init/1","type":"callback"},{"doc":"Execute a run of the tester module.","ref":"Porterage.Tester.html#c:test/1","title":"Porterage.Tester.test/1","type":"callback"},{"doc":"","ref":"Porterage.Tester.html#t:state/0","title":"Porterage.Tester.state/0","type":"type"},{"doc":"","ref":"Porterage.Tester.html#t:test_result/0","title":"Porterage.Tester.test_result/0","type":"type"},{"doc":"Deliverer to write files. Configuration { deliverer: Porterage.Deliverer.FileWrite, deliverer_opts: %{file: _} } See options/0 for a specification of available options.","ref":"Porterage.Deliverer.FileWrite.html","title":"Porterage.Deliverer.FileWrite","type":"module"},{"doc":"","ref":"Porterage.Deliverer.FileWrite.html#t:options/0","title":"Porterage.Deliverer.FileWrite.options/0","type":"type"},{"doc":"Deliverer based on usage of Kernel.apply/3 calls. Data to be delivered will be passed as the first argument. Configuration { deliverer: Porterage.Deliverer.MFArgs, deliverer_opts: %{mfargs: {_, _, _}} } Data to be delivered will always be passed as the first argument with all configured arguments afterwards. See options/0 for a specification of available options.","ref":"Porterage.Deliverer.MFArgs.html","title":"Porterage.Deliverer.MFArgs","type":"module"},{"doc":"","ref":"Porterage.Deliverer.MFArgs.html#t:options/0","title":"Porterage.Deliverer.MFArgs.options/0","type":"type"},{"doc":"Deliverer based on usage of Kernel.send/2 calls. Configuration { deliverer: Porterage.Deliverer.Send, deliverer_opts: %{dest: _} } See options/0 for a specification of available options.","ref":"Porterage.Deliverer.Send.html","title":"Porterage.Deliverer.Send","type":"module"},{"doc":"","ref":"Porterage.Deliverer.Send.html#t:options/0","title":"Porterage.Deliverer.Send.options/0","type":"type"},{"doc":"Fetcher based on results of File.read/1 calls. Configuration { fetcher: Porterage.Fetcher.FileRead, fetcher_opts: %{file: _} } See options/0 for a specification of available options.","ref":"Porterage.Fetcher.FileRead.html","title":"Porterage.Fetcher.FileRead","type":"module"},{"doc":"","ref":"Porterage.Fetcher.FileRead.html#t:options/0","title":"Porterage.Fetcher.FileRead.options/0","type":"type"},{"doc":"Fetcher based on usage of Kernel.apply/3 calls. The configured callable is expected to return {:ok, term} if data has been fetched. Any other return value will be ignored. Configuration { fetcher: Porterage.Fetcher.MFArgs, fetcher_opts: %{mfargs: {_, _, _}} } See options/0 for a specification of available options.","ref":"Porterage.Fetcher.MFArgs.html","title":"Porterage.Fetcher.MFArgs","type":"module"},{"doc":"","ref":"Porterage.Fetcher.MFArgs.html#t:options/0","title":"Porterage.Fetcher.MFArgs.options/0","type":"type"},{"doc":"Scheduler based on usage of Kernel.apply/3 calls. The configured function to call is required to send a message to self() in order to schedule the next tick: GenServer.cast(self(), :tick) Kernel.send(self(), :tick) Process.send_after(self(), :tick, send_after) Configuration { scheduler: Porterage.Scheduler.MFArgs, scheduler_opts: %{mfargs: {_, _, _}} } See options/0 for a specification of available options.","ref":"Porterage.Scheduler.MFArgs.html","title":"Porterage.Scheduler.MFArgs","type":"module"},{"doc":"","ref":"Porterage.Scheduler.MFArgs.html#t:options/0","title":"Porterage.Scheduler.MFArgs.options/0","type":"type"},{"doc":"Scheduler ignoring all trigger requests to force only manual fetching. Configuration { scheduler: Porterage.Scheduler.Never }","ref":"Porterage.Scheduler.Never.html","title":"Porterage.Scheduler.Never","type":"module"},{"doc":"Scheduler triggering once upon startup. Configuration { scheduler: Porterage.Scheduler.Once }","ref":"Porterage.Scheduler.Once.html","title":"Porterage.Scheduler.Once","type":"module"},{"doc":"Scheduler triggering repeatedly after configurable time. Configuration { scheduler: Porterage.Scheduler.Timer, scheduler_opts: %{time: _} } See options/0 for a specification of available options.","ref":"Porterage.Scheduler.Timer.html","title":"Porterage.Scheduler.Timer","type":"module"},{"doc":"","ref":"Porterage.Scheduler.Timer.html#t:options/0","title":"Porterage.Scheduler.Timer.options/0","type":"type"},{"doc":"Tester based on results of File.stat/1 calls. Configuration { tester: Porterage.Tester.FileStat, tester_opts: %{file: _, stat_key: _} } See options/0 for a specification of available options.","ref":"Porterage.Tester.FileStat.html","title":"Porterage.Tester.FileStat","type":"module"},{"doc":"","ref":"Porterage.Tester.FileStat.html#t:options/0","title":"Porterage.Tester.FileStat.options/0","type":"type"},{"doc":"Tester based on usage of Kernel.apply/3 calls. The configured callable will receive a state value as the first parameter. On the first run it will always be nil and afterwards the return value of the last execution. The return value is expected to be {new_state, result}. Configuration { tester: Porterage.Tester.MFArgs, tester_opts: %{mfargs: {_, _, _}} } See options/0 for a specification of available options.","ref":"Porterage.Tester.MFArgs.html","title":"Porterage.Tester.MFArgs","type":"module"},{"doc":"","ref":"Porterage.Tester.MFArgs.html#t:options/0","title":"Porterage.Tester.MFArgs.options/0","type":"type"}]